/*
 *  DLLInjector.c
 *  
 *  Author	: Ahmed Obied (ahmed.obied@gmail.com)
 *  Date	: 11/2008
 *  Version	: 0.2
 *
 *  DLLInjector is a tool for injecting a DLL into a running process. The tool 
 *  optionally displays the process IDs of all running processes in the system. 
 *
 *  Usage	: DLLInjector.exe [option]	
 *  Options	:
 *	/i [DLL path] [Target Process ID] 
 *		Used for injection
 *      /l 
 *		Used to display the list of running processes
 *      /a [DLL path] 
 *		Used to inject a dll into all running processes
 *
 */

#include <windows.h>
#include <tlhelp32.h>
#include <stdio.h>

BOOL Inject(
	LPSTR dllPath, 
	DWORD pID
	)
{
	HANDLE hProcess, hThread;
	LPVOID mRegion;
	BOOL status;
	FARPROC loadLibrary;
	
	printf("[-] Target Process ID: %d\n", pID);
	printf("[-] DLL Path: %s\n\n", dllPath);
	printf("[-] Opening the target process ... ");
	hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pID);
	if (hProcess == NULL) {
		printf("[failure][code: 0x%x]\n", GetLastError());
		return FALSE;
	}
	printf("[success]\n");
	printf("[-] Allocating memory in the target process ... ");
	mRegion = VirtualAllocEx(hProcess, NULL, strlen(dllPath), MEM_COMMIT|MEM_RESERVE, PAGE_READWRITE); 
	if (mRegion == NULL) {
		printf("[failure][code: 0x%x]\n", GetLastError());
		return FALSE;
	}
	printf("[success]\n");
	printf("[-] Writing to the allocated memory in the target process ... ");
	status = WriteProcessMemory(hProcess, mRegion, (LPCVOID)dllPath, strlen(dllPath), NULL);
	if (!status) {
		printf("[failure][code: 0x%x]\n", GetLastError());
		return FALSE;
	}
	printf("[success]\n");
	loadLibrary = GetProcAddress(GetModuleHandle("Kernel32"), "LoadLibraryA");
	printf("[-] Creating a remote thread in the target process ... ");
	hThread = CreateRemoteThread(hProcess, NULL, 0, (LPTHREAD_START_ROUTINE)loadLibrary, mRegion, 0, NULL);
	if (hThread == NULL) {
		printf("[failure][code: 0x%x]\n", GetLastError());
		return FALSE;
	}
	printf("[success]\n");
	WaitForSingleObject(hThread, INFINITE);
	VirtualFreeEx(hProcess, mRegion, strlen(dllPath), MEM_RELEASE);
	CloseHandle(hThread);	
	CloseHandle(hProcess);
	return TRUE;
}

VOID InjectAllProcesses(
	LPSTR dllPath
	)
{
	HANDLE procList;
	PROCESSENTRY32 proc;
	BOOL status;

	printf("[-] Retrieving the list of running processes ... ");
	procList = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if (procList == INVALID_HANDLE_VALUE) {
		printf("[failure][code: 0x%x]\n", GetLastError());
		return;
	}
	printf("[success]\n");
	proc.dwSize = sizeof(PROCESSENTRY32);
	status = Process32First(procList, &proc);
	if (status == FALSE) 
		return;
	while (true) {
		status = Process32Next(procList, &proc);
		if (status == FALSE)
			break;
		printf("\n\n");
		printf("[-] Injecting %s into %s (%d) ... \n", dllPath, proc.szExeFile, proc.th32ProcessID);
		Inject(dllPath, proc.th32ProcessID);
	}
}

VOID DisplayProcesses(
	VOID
	)
{
	HANDLE procList;
	PROCESSENTRY32 proc;
	BOOL status;

	printf("[-] Retrieving the list of running processes ... ");
	procList = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if (procList == INVALID_HANDLE_VALUE) {
		printf("[failure][code: 0x%x]\n", GetLastError());
		return;
	}
	printf("[success]\n");
	proc.dwSize = sizeof(PROCESSENTRY32);
	status = Process32First(procList, &proc);
	if (status == FALSE) 
		return;
	printf("\n PID \t Executable\n\n");
	while (true) {
		status = Process32Next(procList, &proc);
		if (status == FALSE)
			break;
		printf(" %d \t %s\n", proc.th32ProcessID, proc.szExeFile);
	}
}

VOID DisplayUsage(
	LPSTR arg
	)
{
	printf("\nUsage: ./%s [option]\n\n", arg);
	printf("options:\n\n");
	printf("/i [DLL path] [Target Process ID] : this option is used for injection\n");
	printf("/l : this option is used to display the list of running processes\n");
	printf("/a [DLL path] : this option is used to inject a dll into all running processes\n");
}

int main(int argc, char **argv)
{
	DWORD option = 0;
	
	if (argc == 2) {
		if (strcmp(argv[1],"/l") == 0) 
			option = 1;
		else {
			DisplayUsage(argv[0]);
			exit(1);
		}
	} else if (argc == 3) {
		if (strcmp(argv[1], "/a") == 0)
			option = 2;
		else {
			DisplayUsage(argv[0]);
			exit(1);
		}
	} else if (argc == 4) {
		if (strcmp(argv[1],"/i") == 0)
			option = 3;
		else {
			DisplayUsage(argv[0]);
			exit(1);
		}
	} else {
		DisplayUsage(argv[0]);
		exit(1);
	}
	printf("\n");
	printf("[************************************]\n");
	printf("[=] DLLInjector 0.2 by Ahmed Obied [=]\n");
	printf("[************************************]\n");
	printf("\n");
	switch (option) { 
		case 1: 
			DisplayProcesses();
			break;
		case 2:
			InjectAllProcesses(argv[2]);
			break;
		case 3: {
			if (Inject(argv[2], atoi(argv[3])))
				printf("\n[-] Injecting \"%s\" into %s succeeded\n", argv[2], argv[3]);
			else
				printf("\n[-] Injecting \"%s\" into %s failed\n", argv[2], argv[3]);
			}
	}
	return 0;
}
